Hex Artifact Content

Artifact 1e6b680b6ec1968ba393bd9716e09869d405705e:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 48 52 45 41 44 56 45 52 53 3d 22 32 2e 36 2e 35  HREADVERS="2.6.5
0100: 22 0a 53 52 43 3d 22 73 72 63 2f 74 68 72 65 61  ".SRC="src/threa
0110: 64 2d 24 7b 54 48 52 45 41 44 56 45 52 53 7d 2e  d-${THREADVERS}.
0120: 74 61 72 2e 67 7a 22 0a 53 52 43 55 52 4c 3d 22  tar.gz".SRCURL="
0130: 68 74 74 70 3a 2f 2f 73 6f 75 72 63 65 66 6f 72  http://sourcefor
0140: 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63 74 73 2f  ge.net/projects/
0150: 74 63 6c 2f 66 69 6c 65 73 2f 54 68 72 65 61 64  tcl/files/Thread
0160: 25 32 30 45 78 74 65 6e 73 69 6f 6e 2f 24 7b 54  %20Extension/${T
0170: 48 52 45 41 44 56 45 52 53 7d 2f 74 68 72 65 61  HREADVERS}/threa
0180: 64 24 7b 54 48 52 45 41 44 56 45 52 53 7d 2e 74  d${THREADVERS}.t
0190: 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64 22 0a  ar.gz/download".
01a0: 42 55 49 4c 44 44 49 52 3d 22 24 28 70 77 64 29  BUILDDIR="$(pwd)
01b0: 2f 62 75 69 6c 64 2f 74 68 72 65 61 64 24 7b 54  /build/thread${T
01c0: 48 52 45 41 44 56 45 52 53 7d 22 0a 4f 55 54 44  HREADVERS}".OUTD
01d0: 49 52 3d 22 24 28 70 77 64 29 2f 6f 75 74 22 0a  IR="$(pwd)/out".
01e0: 49 4e 53 54 44 49 52 3d 22 24 28 70 77 64 29 2f  INSTDIR="$(pwd)/
01f0: 69 6e 73 74 22 0a 65 78 70 6f 72 74 20 54 48 52  inst".export THR
0200: 45 41 44 56 45 52 53 20 53 52 43 20 53 52 43 55  EADVERS SRC SRCU
0210: 52 4c 20 42 55 49 4c 44 44 49 52 20 4f 55 54 44  RL BUILDDIR OUTD
0220: 49 52 20 49 4e 53 54 44 49 52 0a 0a 23 20 53 65  IR INSTDIR..# Se
0230: 74 20 63 6f 6e 66 69 67 75 72 65 20 6f 70 74 69  t configure opti
0240: 6f 6e 73 20 66 6f 72 20 74 68 69 73 20 73 75 62  ons for this sub
0250: 2d 70 72 6f 6a 65 63 74 0a 4c 44 46 4c 41 47 53  -project.LDFLAGS
0260: 3d 22 24 7b 4b 43 5f 54 48 52 45 41 44 5f 4c 44  ="${KC_THREAD_LD
0270: 46 4c 41 47 53 7d 22 0a 43 46 4c 41 47 53 3d 22  FLAGS}".CFLAGS="
0280: 24 7b 4b 43 5f 54 48 52 45 41 44 5f 43 46 4c 41  ${KC_THREAD_CFLA
0290: 47 53 7d 22 0a 43 50 50 46 4c 41 47 53 3d 22 24  GS}".CPPFLAGS="$
02a0: 7b 4b 43 5f 54 48 52 45 41 44 5f 43 50 50 46 4c  {KC_THREAD_CPPFL
02b0: 41 47 53 7d 22 0a 4c 49 42 53 3d 22 24 7b 4b 43  AGS}".LIBS="${KC
02c0: 5f 54 48 52 45 41 44 5f 4c 49 42 53 7d 22 0a 65  _THREAD_LIBS}".e
02d0: 78 70 6f 72 74 20 4c 44 46 4c 41 47 53 20 43 46  xport LDFLAGS CF
02e0: 4c 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c 49  LAGS CPPFLAGS LI
02f0: 42 53 0a 0a 72 6d 20 2d 72 66 20 27 62 75 69 6c  BS..rm -rf 'buil
0300: 64 27 20 27 6f 75 74 27 20 27 69 6e 73 74 27 0a  d' 'out' 'inst'.
0310: 6d 6b 64 69 72 20 27 62 75 69 6c 64 27 20 27 6f  mkdir 'build' 'o
0320: 75 74 27 20 27 69 6e 73 74 27 20 7c 7c 20 65 78  ut' 'inst' || ex
0330: 69 74 20 31 0a 0a 23 20 44 65 74 65 72 6d 69 6e  it 1..# Determin
0340: 65 20 69 66 20 54 68 72 65 61 64 73 20 69 73 20  e if Threads is 
0350: 65 76 65 6e 20 6e 65 65 64 65 64 0a 28 0a 09 54  even needed.(..T
0360: 43 4c 5f 56 45 52 53 49 4f 4e 3d 22 75 6e 6b 6e  CL_VERSION="unkn
0370: 6f 77 6e 22 0a 09 69 66 20 5b 20 2d 66 20 22 24  own"..if [ -f "$
0380: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74  {TCLCONFIGDIR}/t
0390: 63 6c 43 6f 6e 66 69 67 2e 73 68 22 20 5d 3b 20  clConfig.sh" ]; 
03a0: 74 68 65 6e 0a 09 09 73 6f 75 72 63 65 20 22 24  then...source "$
03b0: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74  {TCLCONFIGDIR}/t
03c0: 63 6c 43 6f 6e 66 69 67 2e 73 68 22 0a 09 66 69  clConfig.sh"..fi
03d0: 0a 0a 09 69 66 20 65 63 68 6f 20 22 24 7b 54 43  ...if echo "${TC
03e0: 4c 5f 56 45 52 53 49 4f 4e 7d 22 20 7c 20 67 72  L_VERSION}" | gr
03f0: 65 70 20 27 5e 38 5c 2e 5b 34 35 5d 24 27 20 3e  ep '^8\.[45]$' >
0400: 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a  /dev/null; then.
0410: 09 09 23 20 54 68 72 65 61 64 73 20 6d 61 79 20  ..# Threads may 
0420: 62 65 20 72 65 71 75 69 72 65 64 20 66 6f 72 20  be required for 
0430: 54 63 6c 20 38 2e 34 20 61 6e 64 20 54 63 6c 20  Tcl 8.4 and Tcl 
0440: 38 2e 35 0a 0a 20 20 20 20 20 20 20 20 20 20 20  8.5..           
0450: 20 20 20 20 20 65 78 69 74 20 30 0a 20 20 20 20       exit 0.    
0460: 20 20 20 20 66 69 0a 0a 09 69 66 20 5b 20 22 24      fi...if [ "$
0470: 7b 54 43 4c 5f 56 45 52 53 49 4f 4e 7d 22 20 3d  {TCL_VERSION}" =
0480: 20 22 75 6e 6b 6e 6f 77 6e 22 20 5d 3b 20 74 68   "unknown" ]; th
0490: 65 6e 0a 09 09 23 20 49 66 20 77 65 20 64 6f 6e  en...# If we don
04a0: 74 20 6b 6e 6f 77 20 77 68 61 74 20 76 65 72 73  t know what vers
04b0: 69 6f 6e 20 6f 66 20 54 63 6c 20 77 65 20 61 72  ion of Tcl we ar
04c0: 65 20 62 75 69 6c 64 69 6e 67 2c 20 62 75 69 6c  e building, buil
04d0: 64 0a 09 09 23 20 54 68 72 65 61 64 73 20 6a 75  d...# Threads ju
04e0: 73 74 20 69 6e 20 63 61 73 65 2e 0a 0a 09 09 65  st in case.....e
04f0: 78 69 74 20 30 0a 09 66 69 0a 0a 09 23 20 41 6c  xit 0..fi...# Al
0500: 6c 20 6f 74 68 65 72 20 76 65 72 73 69 6f 6e 73  l other versions
0510: 20 64 6f 20 6e 6f 74 20 72 65 71 75 69 72 65 20   do not require 
0520: 54 68 72 65 61 64 73 0a 09 65 63 68 6f 20 22 53  Threads..echo "S
0530: 6b 69 70 70 69 6e 67 20 62 75 69 6c 64 69 6e 67  kipping building
0540: 20 54 68 72 65 61 64 73 2c 20 6e 6f 74 20 72 65   Threads, not re
0550: 71 75 69 72 65 64 20 66 6f 72 20 24 7b 54 43 4c  quired for ${TCL
0560: 5f 56 45 52 53 49 4f 4e 7d 22 0a 09 65 78 69 74  _VERSION}"..exit
0570: 20 31 0a 29 20 7c 7c 20 65 78 69 74 20 30 0a 0a   1.) || exit 0..
0580: 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 53 52 43  if [ ! -f "${SRC
0590: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 6b 64 69  }" ]; then..mkdi
05a0: 72 20 27 73 72 63 27 20 3e 2f 64 65 76 2f 6e 75  r 'src' >/dev/nu
05b0: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a  ll 2>/dev/null..
05c0: 09 69 66 20 5b 20 21 20 2d 64 20 27 62 75 69 6c  .if [ ! -d 'buil
05d0: 64 73 72 63 27 20 5d 3b 20 74 68 65 6e 0a 09 09  dsrc' ]; then...
05e0: 72 6d 20 2d 66 20 22 24 7b 53 52 43 7d 2e 74 6d  rm -f "${SRC}.tm
05f0: 70 22 0a 09 09 77 67 65 74 20 2d 4f 20 22 24 7b  p"...wget -O "${
0600: 53 52 43 7d 2e 74 6d 70 22 20 22 24 7b 53 52 43  SRC}.tmp" "${SRC
0610: 55 52 4c 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  URL}" || exit 1.
0620: 09 09 6d 76 20 22 24 7b 53 52 43 7d 2e 74 6d 70  ..mv "${SRC}.tmp
0630: 22 20 22 24 7b 53 52 43 7d 22 0a 09 66 69 0a 66  " "${SRC}"..fi.f
0640: 69 0a 0a 28 0a 09 63 64 20 27 62 75 69 6c 64 27  i..(..cd 'build'
0650: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 69 66 20   || exit 1...if 
0660: 5b 20 21 20 2d 64 20 27 2e 2e 2f 62 75 69 6c 64  [ ! -d '../build
0670: 73 72 63 27 20 5d 3b 20 74 68 65 6e 0a 09 09 67  src' ]; then...g
0680: 7a 69 70 20 2d 64 63 20 22 2e 2e 2f 24 7b 53 52  zip -dc "../${SR
0690: 43 7d 22 20 7c 20 74 61 72 20 2d 78 66 20 2d 0a  C}" | tar -xf -.
06a0: 09 65 6c 73 65 0a 09 09 63 70 20 2d 72 70 20 2e  .else...cp -rp .
06b0: 2e 2f 62 75 69 6c 64 73 72 63 2f 2a 20 27 2e 2f  ./buildsrc/* './
06c0: 27 0a 09 66 69 0a 0a 09 63 64 20 22 24 7b 42 55  '..fi...cd "${BU
06d0: 49 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74  ILDDIR}" || exit
06e0: 20 31 0a 0a 0a 09 23 20 54 72 79 20 74 6f 20 62   1....# Try to b
06f0: 75 69 6c 64 20 61 73 20 61 20 73 68 61 72 65 64  uild as a shared
0700: 20 6f 62 6a 65 63 74 20 69 66 20 72 65 71 75 65   object if reque
0710: 73 74 65 64 0a 09 69 66 20 5b 20 22 24 7b 53 54  sted..if [ "${ST
0720: 41 54 49 43 54 48 52 45 41 44 7d 22 20 3d 20 22  ATICTHREAD}" = "
0730: 30 22 20 5d 3b 20 74 68 65 6e 0a 09 09 74 72 79  0" ]; then...try
0740: 6f 70 74 73 3d 22 2d 2d 65 6e 61 62 6c 65 2d 73  opts="--enable-s
0750: 68 61 72 65 64 20 2d 2d 64 69 73 61 62 6c 65 2d  hared --disable-
0760: 73 68 61 72 65 64 22 0a 09 65 6c 69 66 20 5b 20  shared"..elif [ 
0770: 22 24 7b 53 54 41 54 49 43 54 48 52 45 41 44 7d  "${STATICTHREAD}
0780: 22 20 3d 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a  " = "1" ]; then.
0790: 09 09 74 72 79 6f 70 74 73 3d 22 2d 2d 64 69 73  ..tryopts="--dis
07a0: 61 62 6c 65 2d 73 68 61 72 65 64 22 0a 09 65 6c  able-shared"..el
07b0: 73 65 0a 09 09 74 72 79 6f 70 74 73 3d 22 2d 2d  se...tryopts="--
07c0: 65 6e 61 62 6c 65 2d 73 68 61 72 65 64 22 0a 09  enable-shared"..
07d0: 66 69 0a 0a 09 53 41 56 45 5f 43 46 4c 41 47 53  fi...SAVE_CFLAGS
07e0: 3d 22 24 7b 43 46 4c 41 47 53 7d 22 0a 09 66 6f  ="${CFLAGS}"..fo
07f0: 72 20 74 72 79 6f 70 74 20 69 6e 20 24 74 72 79  r tryopt in $try
0800: 6f 70 74 73 20 5f 5f 66 61 69 6c 5f 5f 3b 20 64  opts __fail__; d
0810: 6f 0a 09 09 23 20 43 6c 65 61 6e 20 75 70 2c 20  o...# Clean up, 
0820: 69 66 20 6e 65 65 64 65 64 0a 09 09 6d 61 6b 65  if needed...make
0830: 20 64 69 73 74 63 6c 65 61 6e 20 3e 2f 64 65 76   distclean >/dev
0840: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
0850: 6c 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 49 4e  l...rm -rf "${IN
0860: 53 54 44 49 52 7d 22 0a 09 09 6d 6b 64 69 72 20  STDIR}"...mkdir 
0870: 22 24 7b 49 4e 53 54 44 49 52 7d 22 0a 0a 09 09  "${INSTDIR}"....
0880: 69 66 20 5b 20 22 24 7b 74 72 79 6f 70 74 7d 22  if [ "${tryopt}"
0890: 20 3d 20 22 5f 5f 66 61 69 6c 5f 5f 22 20 5d 3b   = "__fail__" ];
08a0: 20 74 68 65 6e 0a 09 09 09 65 78 69 74 20 31 0a   then....exit 1.
08b0: 09 09 66 69 0a 0a 09 09 69 66 20 5b 20 22 24 7b  ..fi....if [ "${
08c0: 74 72 79 6f 70 74 7d 22 20 3d 3d 20 22 2d 2d 65  tryopt}" == "--e
08d0: 6e 61 62 6c 65 2d 73 68 61 72 65 64 22 20 5d 3b  nable-shared" ];
08e0: 20 74 68 65 6e 0a 09 09 09 69 73 73 68 61 72 65   then....isshare
08f0: 64 3d 22 31 22 0a 09 09 65 6c 73 65 0a 09 09 09  d="1"...else....
0900: 69 73 73 68 61 72 65 64 3d 22 30 22 0a 09 09 66  isshared="0"...f
0910: 69 0a 0a 09 09 23 20 49 66 20 62 75 69 6c 64 20  i....# If build 
0920: 61 20 73 74 61 74 69 63 20 54 4c 53 20 66 6f 72  a static TLS for
0930: 20 4b 69 74 44 4c 4c 2c 20 65 6e 73 75 72 65 20   KitDLL, ensure 
0940: 74 68 61 74 20 77 65 20 75 73 65 20 50 49 43 0a  that we use PIC.
0950: 09 09 23 20 73 6f 20 74 68 61 74 20 69 74 20 63  ..# so that it c
0960: 61 6e 20 62 65 20 6c 69 6e 6b 65 64 20 69 6e 74  an be linked int
0970: 6f 20 74 68 65 20 73 68 61 72 65 64 20 6f 62 6a  o the shared obj
0980: 65 63 74 0a 09 09 69 66 20 5b 20 22 24 7b 69 73  ect...if [ "${is
0990: 73 68 61 72 65 64 7d 22 20 3d 20 22 30 22 20 2d  shared}" = "0" -
09a0: 61 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d 22  a "${KITTARGET}"
09b0: 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20 74   = "kitdll" ]; t
09c0: 68 65 6e 0a 09 09 09 43 46 4c 41 47 53 3d 22 24  hen....CFLAGS="$
09d0: 7b 53 41 56 45 5f 43 46 4c 41 47 53 7d 20 2d 66  {SAVE_CFLAGS} -f
09e0: 50 49 43 22 0a 09 09 65 6c 73 65 0a 09 09 09 43  PIC"...else....C
09f0: 46 4c 41 47 53 3d 22 24 7b 53 41 56 45 5f 43 46  FLAGS="${SAVE_CF
0a00: 4c 41 47 53 7d 22 0a 09 09 66 69 0a 09 09 65 78  LAGS}"...fi...ex
0a10: 70 6f 72 74 20 43 46 4c 41 47 53 0a 0a 09 09 69  port CFLAGS....i
0a20: 66 20 5b 20 22 24 7b 69 73 73 68 61 72 65 64 7d  f [ "${isshared}
0a30: 22 20 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a  " = '0' ]; then.
0a40: 09 09 09 73 65 64 20 27 73 40 55 53 45 5f 54 43  ...sed 's@USE_TC
0a50: 4c 5f 53 54 55 42 53 40 58 58 58 5f 54 43 4c 5f  L_STUBS@XXX_TCL_
0a60: 53 54 55 42 53 40 67 27 20 63 6f 6e 66 69 67 75  STUBS@g' configu
0a70: 72 65 20 3e 20 63 6f 6e 66 69 67 75 72 65 2e 6e  re > configure.n
0a80: 65 77 0a 09 09 65 6c 73 65 0a 09 09 09 73 65 64  ew...else....sed
0a90: 20 27 73 40 58 58 58 5f 54 43 4c 5f 53 54 55 42   's@XXX_TCL_STUB
0aa0: 53 40 55 53 45 5f 54 43 4c 5f 53 54 55 42 53 40  S@USE_TCL_STUBS@
0ab0: 67 27 20 63 6f 6e 66 69 67 75 72 65 20 3e 20 63  g' configure > c
0ac0: 6f 6e 66 69 67 75 72 65 2e 6e 65 77 0a 09 09 66  onfigure.new...f
0ad0: 69 0a 09 09 63 61 74 20 63 6f 6e 66 69 67 75 72  i...cat configur
0ae0: 65 2e 6e 65 77 20 3e 20 63 6f 6e 66 69 67 75 72  e.new > configur
0af0: 65 0a 09 09 72 6d 20 2d 66 20 63 6f 6e 66 69 67  e...rm -f config
0b00: 75 72 65 2e 6e 65 77 0a 0a 09 09 28 0a 09 09 09  ure.new....(....
0b10: 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e  echo "Running: .
0b20: 2f 63 6f 6e 66 69 67 75 72 65 20 24 74 72 79 6f  /configure $tryo
0b30: 70 74 20 2d 2d 64 69 73 61 62 6c 65 2d 73 79 6d  pt --disable-sym
0b40: 62 6f 6c 73 20 2d 2d 70 72 65 66 69 78 3d 5c 22  bols --prefix=\"
0b50: 24 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 65  ${INSTDIR}\" --e
0b60: 78 65 63 2d 70 72 65 66 69 78 3d 5c 22 24 7b 49  xec-prefix=\"${I
0b70: 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 6c 69 62 64  NSTDIR}\" --libd
0b80: 69 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 2f  ir=\"${INSTDIR}/
0b90: 6c 69 62 5c 22 20 2d 2d 77 69 74 68 2d 74 63 6c  lib\" --with-tcl
0ba0: 3d 5c 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49  =\"${TCLCONFIGDI
0bb0: 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  R}\" ${CONFIGURE
0bc0: 45 58 54 52 41 7d 22 0a 09 09 09 2e 2f 63 6f 6e  EXTRA}"...../con
0bd0: 66 69 67 75 72 65 20 24 74 72 79 6f 70 74 20 2d  figure $tryopt -
0be0: 2d 64 69 73 61 62 6c 65 2d 73 79 6d 62 6f 6c 73  -disable-symbols
0bf0: 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 49 4e 53   --prefix="${INS
0c00: 54 44 49 52 7d 22 20 2d 2d 65 78 65 63 2d 70 72  TDIR}" --exec-pr
0c10: 65 66 69 78 3d 22 24 7b 49 4e 53 54 44 49 52 7d  efix="${INSTDIR}
0c20: 22 20 2d 2d 6c 69 62 64 69 72 3d 22 24 7b 49 4e  " --libdir="${IN
0c30: 53 54 44 49 52 7d 2f 6c 69 62 22 20 2d 2d 77 69  STDIR}/lib" --wi
0c40: 74 68 2d 74 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e  th-tcl="${TCLCON
0c50: 46 49 47 44 49 52 7d 22 20 24 7b 43 4f 4e 46 49  FIGDIR}" ${CONFI
0c60: 47 55 52 45 45 58 54 52 41 7d 0a 0a 09 09 09 65  GUREEXTRA}.....e
0c70: 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 24 7b  cho "Running: ${
0c80: 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 22 0a 09 09 09  MAKE:-make}"....
0c90: 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 7c 7c  ${MAKE:-make} ||
0ca0: 20 65 78 69 74 20 31 0a 0a 09 09 09 65 63 68 6f   exit 1.....echo
0cb0: 20 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b   "Running: ${MAK
0cc0: 45 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c  E:-make} install
0cd0: 22 0a 09 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b  "....${MAKE:-mak
0ce0: 65 7d 20 69 6e 73 74 61 6c 6c 0a 09 09 29 20 7c  e} install...) |
0cf0: 7c 20 63 6f 6e 74 69 6e 75 65 0a 0a 09 09 62 72  | continue....br
0d00: 65 61 6b 0a 09 64 6f 6e 65 0a 0a 09 6d 6b 64 69  eak..done...mkdi
0d10: 72 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62  r "${OUTDIR}/lib
0d20: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 63 70 20  " || exit 1..cp 
0d30: 2d 72 20 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c  -r "${INSTDIR}/l
0d40: 69 62 22 2f 74 68 72 65 61 64 2a 2f 20 22 24 7b  ib"/thread*/ "${
0d50: 4f 55 54 44 49 52 7d 2f 6c 69 62 2f 22 0a 09 72  OUTDIR}/lib/"..r
0d60: 6d 20 2d 66 20 22 24 7b 4f 55 54 44 49 52 7d 22  m -f "${OUTDIR}"
0d70: 2f 6c 69 62 2f 74 68 72 65 61 64 2a 2f 2a 2e 61  /lib/thread*/*.a
0d80: 0a 0a 09 69 66 20 5b 20 22 24 7b 69 73 73 68 61  ...if [ "${issha
0d90: 72 65 64 7d 22 20 3d 20 27 30 27 20 5d 3b 20 74  red}" = '0' ]; t
0da0: 68 65 6e 0a 09 09 63 61 74 20 3c 3c 20 5f 45 4f  hen...cat << _EO
0db0: 46 5f 20 3e 20 22 24 7b 4f 55 54 44 49 52 7d 2f  F_ > "${OUTDIR}/
0dc0: 6c 69 62 2f 74 68 72 65 61 64 24 7b 54 48 52 45  lib/thread${THRE
0dd0: 41 44 56 45 52 53 7d 2f 70 6b 67 49 6e 64 65 78  ADVERS}/pkgIndex
0de0: 2e 74 63 6c 22 0a 70 61 63 6b 61 67 65 20 69 66  .tcl".package if
0df0: 6e 65 65 64 65 64 20 54 68 72 65 61 64 20 24 7b  needed Thread ${
0e00: 54 48 52 45 41 44 56 45 52 53 7d 20 5b 6c 69 73  THREADVERS} [lis
0e10: 74 20 6c 6f 61 64 20 22 22 20 54 68 72 65 61 64  t load "" Thread
0e20: 5d 0a 70 61 63 6b 61 67 65 20 69 66 6e 65 65 64  ].package ifneed
0e30: 65 64 20 54 74 72 61 63 65 20 24 7b 54 48 52 45  ed Ttrace ${THRE
0e40: 41 44 56 45 52 53 7d 20 5b 6c 69 73 74 20 73 6f  ADVERS} [list so
0e50: 75 72 63 65 20 5b 66 69 6c 65 20 6a 6f 69 6e 20  urce [file join 
0e60: 24 64 69 72 20 74 74 72 61 63 65 2e 74 63 6c 5d  $dir ttrace.tcl]
0e70: 5d 0a 5f 45 4f 46 5f 0a 09 66 69 0a 0a 09 22 24  ]._EOF_..fi..."$
0e80: 7b 53 54 52 49 50 3a 2d 73 74 72 69 70 7d 22 20  {STRIP:-strip}" 
0e90: 2d 67 20 22 24 7b 4f 55 54 44 49 52 7d 22 2f 6c  -g "${OUTDIR}"/l
0ea0: 69 62 2f 74 68 72 65 61 64 2a 2f 2a 2e 73 6f 20  ib/thread*/*.so 
0eb0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
0ec0: 76 2f 6e 75 6c 6c 0a 0a 09 65 78 69 74 20 30 0a  v/null...exit 0.
0ed0: 29 20 7c 7c 20 65 78 69 74 20 31 0a 0a 65 78 69  ) || exit 1..exi
0ee0: 74 20 30 0a                                      t 0.